<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
			text-align: left;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Database Queries</h1>

		<p>These outline the ways in which you can submit queries to your database.</p>
	</div>

	<div class="content">
		<h1>$this->db->query()</h1>

		<p>To submit a query you can use the following method.</p>

		<div class="example">
			$this->db->query('SQL QUERY HERE');
		</div>

		<p>The <b>query()</b> method returns a database result object when 'read' type queries run, which you can
		then use to show database results.  When a 'write' type of query is used it will simply return a true or false
		depending on success or failure.  When retrieving data you will typically assign the return value to a 
		variable</p>

		<div class="example">
			$query = $this->db->query('SQL QUERY HERE');
		</div>
	</div>

	<div class="content">
		<h1>$this->db->simple_query()</h1>

		<p>This is a simplified version of the <b>query()</b> method.  It will only return true or false.  It will
		not return a database result set, nor does it set the query timer, or compile bind data, or store your query
		for debugging.  It simply submits a query.</p>
	</div>

	<div class="content">
		<h1>Adding Database Prefixes Manually</h1>
		
		<p>If you have configured a database prefix and would like to add it in manually, you can use the following.</p>

		<div class="example">
			$this->db->dbprefix('tablename');
			// outputs prefix_tablename
		</div>
	</div>

	<div class="content">
		<h1>Protecting Identifiers</h1>
		
		<p>In many databases it is adviable for you to protect table and field names, for example with backticks in MySQL.  The Active Record class
		automatically protects its queries.  If you need to manually protect an identifier you can use the following.</p>

		<div class="example">
			$this->db->protect_identifiers('table_name');
		</div>
	</div>

	<div class="content">
		<h1>Escaping SQL Queries</h1>

		<p>It is very good practice to escape your data that is being inserted into a database.  CarbonPHP provides
		two methods to help you do this.</p>

		<ol>
			<li><b>$this->db->escape()</b> - this method determines the data type so that it can escape only string
			data.  It also automatically adds single quotes around the data.</li>
			<li><b>$this->db->escape_str()</b> - this method escapes data regardless of the type.  Most of the time
			the above method will be used instead of this one.</li>
		</ol>
	</div>

	<div class="content">
		<h1>Query Binding</h1>

		<p>Binding enables you to simplify your SQL query syntax by letting CarbonPHP put the queries together for you.
		Consider the following example.</p>

		<div class="example">
			$sql = 'SELECT * FROM `some_table` WHERE `id` = ? AND `status` = ? AND `author` = ?';<br />
			<br />
			$this->db->query($sql, array(3, 'inprint', 'Charlie'));
		</div>

		<p>The question marks in the query are replaced by the values found in the array passed to the method in the
		second parameter.  Another benefit of using binds are that they automatically escape values producing
		safer queries.</p>
	</div>
</body>

</html>
